class Square {
  int suji;
  int dan;
}

class Piece {
  int type;
}

// 指し手クラス
class Move {
  Square from;
  Square to;
  Piece movePiece;
  bool promote;
  Piece capturePice;
  bool drop;
}

const int promote = 8;
const int enemy = 16;

const int Empty = 0;
const int P = 1;
const int L = 2;
const int N = 3;
const int S = 4;
const int G = 5;
const int B = 6;
const int R = 7;
const int K = 8;
const int pP = P + promote;
const int pL = L + promote;
const int pN = N + promote;
const int pS = S + promote;
const int pB = B + promote;
const int pR = R + promote;
const int p = P + enemy;
const int l = L + enemy;
const int n = N + enemy;
const int s = S + enemy;
const int g = G + enemy;
const int b = B + enemy;
const int r = R + enemy;
const int k = K + enemy;
const int pp = p + promote;
const int pl = l + promote;
const int pn = n + promote;
const int ps = s + promote;
const int pb = b + promote;
const int pr = r + promote;

class Position {
  Map<Square, Piece> board;
  Map<Piece, int> hand;
  bool turn;
  bool offence;
  List<Move> moves;
}
